#ifndef PAN_FILE_LIB
#define PAN_FILE_LIB

#include "file_med.h"

#ifdef __cplusplus
extern "C" {
#endif

/*********** API Level Functions *******/

int Pan_Extract_Auto(Pan_PassList *pPassList, char *path, char *ext)
{
 *pPassList=Pan_PassList_alloc();
 if (*pPassList==NULL) return(-201);
 (*pPassList)->next=NULL;
 return(extract(*pPassList,path,ext));
}

int Pan_GetNDSInfo(Pan_NDSBrowse *pNDSBrowse, char *path, char *ext)
{
 *pNDSBrowse=Pan_NDSBrowse_alloc();
 if (*pNDSBrowse==NULL) return(-201);
 (*pNDSBrowse)->next=NULL;
 return(getndsinfo(*pNDSBrowse,path,ext));
}

int Pan_GetValueInfo(uint8 **out, uint32 *out_lengh, uint32 *data_lengh,
                     uint32 search_object, uint32 search_attribute, char *path,
                     char *ext)
{
 if (search_attribute==0xffffffff) return(-205);
 return (getvalueinfo(out,out_lengh,data_lengh,search_object,search_attribute,
                      path,ext));
}

int Pan_Convert_Auto(char *path, char *file, char *ext)
{
 int i;
 for(i=0;i<strlen(file);i++) file[i]=toupper(file[i]);
 if ( (!strstr(file,"BACKUP.DS"))&&(!strstr(file,"BACKUP.NDS"))&&
      (!strstr(file,"DSREPAIR.DIB")) ) return(-199);
 return(convert(path,file,ext));
}

int Pan_PassList_read(char *readfile,Pan_PassList *pPassList)
{
 FILE *fPassList; PASSLIST record;
 Pan_PassList tmp;
 int TEST=FALSE;

 /* Allocate memory before reading file to solve abend pb when calling */
 /* Pan_free(..) with no calloc done on the argument */
 *pPassList=Pan_PassList_alloc(); /* Allocate first block of memory */
 if (*pPassList==NULL) return(-201);
 tmp=*pPassList;

 fPassList=fopen(readfile,"rb");  /* Open file */
 if (!fPassList) return(-300);
 rewind(fPassList);

 while (!feof(fPassList))
  {
    if(fread(&record,size_passlist,1,fPassList))
     {
      if (TEST)
      {tmp->next=Pan_PassList_alloc();
       if (tmp->next==NULL) return(-201);
       tmp=tmp->next;
      }
      record_to_pPassList(&record,tmp);
      TEST=TRUE; /*We have to do this dumb TEST thing, otherwise we*/
     }           /*allways allocate one more record than needed*/
  }
  fclose(fPassList);
  return(0);
}

int Pan_PassList_write(char *writefile,Pan_PassList pPassList)
{
 FILE *fPassList; PASSLIST record;
 Pan_PassList q;

 fPassList=fopen(writefile,"wb");  /* Open file */
 if (!fPassList) return(-300);

 for (q=pPassList;q!=NULL;q=q->next)
  {
    pPassList_to_record(q,&record);
    if(!fwrite(&record,size_passlist,1,fPassList))
     {fclose(fPassList);
      return(-301);
     }
  }
  fclose(fPassList);
  return(0);
}

int Pan_PassHack_read(char *readfile,Pan_PassHack *pPassHack)
{
 FILE *fPassHack; PASSHACK record;

 fPassHack=fopen(readfile,"rb");  /* Open file */
 if (!fPassHack) return(-300);
 rewind(fPassHack);

 if (!fread(&record,size_passhack,1,fPassHack)) return(-301);
 record_to_pPassHack(&record,pPassHack);

 fclose(fPassHack);
 return(0);
}

int Pan_PassHack_write(char *writefile,Pan_PassHack *pPassHack)
{
 FILE *fPassHack; PASSHACK record;

 fPassHack=fopen(writefile,"wb");  /* Open file */
 if (!fPassHack) return(-300);

 pPassHack_to_record(pPassHack,&record);
 if (!fwrite(&record,size_passhack,1,fPassHack)) return(-301);

 fclose(fPassHack);
 return(0);
}

int Pan_file_write_unik(char *writefile,uint8 *data, uint32 datalen)
{
 FILE *ffilewrite;
 char string[20];

 if (datalen<=0) return(-300);

 /* I'd rather use __file_exists from un*x standard <unistd.h> lib */
 /* but RSXNT lib dosen't have an equivalent, damn... */
 ffilewrite=fopen(writefile,"r");
 if(ffilewrite)
  {
   fclose(ffilewrite);
   sprintf(string,"%d",(int)time(0));
   if ((strlen(writefile))<(MAXPATHLEN+MAXFNAMELEN-strlen(string)-1))
    {
     strcat(writefile,".");
     strcat(writefile,string);
    }
   else return(-300);
  }

 ffilewrite=fopen(writefile,"wb");  /* Open file */
 if (!ffilewrite) return(-300);

 if (!fwrite(data,sizeof(uint8),datalen,ffilewrite)) return(-301);

 fclose(ffilewrite);
 return(0);
}
/***********************End of API level functions****************/


#ifdef __cplusplus
}
#endif

#endif /* PAN_FILE_LIB */
